#include "list.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void traverse_list(struct ListNode *head, void (*func)(char *string))
{
  while (head) {
    (*func)(head->string);
 
    head = head->next;
  }
}

void prt_(char *string)
{
  printf("%s | ",string);
}

struct ListNode *create_node(char str[])
{
  struct ListNode *ptr = (struct ListNode *)malloc(sizeof (struct ListNode));
  if (ptr) {
    ptr->string = (char *)malloc(strlen(str)+1);
    if (ptr->string){
      strcpy(ptr->string, str);
      ptr->next = 0;
    }
  }
  
  return ptr;
}

void destroy(struct ListNode *node){
  struct ListNode *n2;
  if (node->next!=0)n2=node->next->next;else n2=0;
  free(node->next);
  node->next=n2;
}

void destroy_node(struct ListNode *node){
  struct ListNode *n2;
  while (node!=0){
    n2=node->next;
    free(node->string);
    node->next=0;
    free(node);
    node=n2;
  }
}

void push(struct ListNode **n1, char str[]){
  struct ListNode *tmp=*n1;
  *n1=create_node(str);
  (*n1)->next=tmp;
}
/*
void push(struct ListNode **n1, char str[]){
  struct ListNode *n2=create_node(str);
  struct ListNode *tmp=*n1;
  *n1=n2;
  (*n1)->next=tmp;
}
*/
void pushn(struct ListNode **n1, char str[], int len){
  struct ListNode *tmp=*n1;
  int i;
  struct ListNode *n2 = (struct ListNode *)malloc(sizeof (struct ListNode));
  if (n2) {
    n2->string = (char *)malloc(len);
    if (n2->string){
      for (i=0;i<len;i++)n2->string[i]=str[i];
      n2->next = 0;
    }
  }
  *n1=n2;
  (*n1)->next=tmp;
}

void pop(struct ListNode **n1, char str[]){
  struct ListNode *n2;
  if ((*n1)==0)return;
  n2=(*n1)->next;
  strcpy(str,(*n1)->string);
  free((*n1)->string);
  (*n1)->next=0;
  free(*n1);
  *n1=n2;
}

void popn(struct ListNode **n1, char str[], int len){
  struct ListNode *n2;
  int i;
  if ((*n1)==0)return;
  n2=(*n1)->next;
  for (i=0;i<len;i++)str[i]=(*n1)->string[i];
  free((*n1)->string);
  (*n1)->next=0;
  free(*n1);
  *n1=n2;
}

int pushif(struct ListNode **tmpname, char tmpstr[]){
  struct ListNode *tn=*tmpname;
  while ((tn)&&(tn->string)&&(strcmp(tn->string,tmpstr)!=0))tn=tn->next;
  if(!tn){
    push(tmpname,tmpstr);
    return 1;
  }
  return 0;
}

int popif (struct ListNode **tmpname, char tmpstr[]){
  struct ListNode *tn=*tmpname, *tn1;
  if(!*tmpname)return 0;
  if(!(*tmpname)->string)return 0;
  if(strcmp((*tmpname)->string,tmpstr)==0){
    tn=(*tmpname)->next;
    (*tmpname)->next=0;
    destroy_node(*tmpname);
    *tmpname=tn;
    return 1;
  }
  if(!(*tmpname)->next)return 0;
  if(!(*tmpname)->next->string)return 0;
  if(strcmp((*tmpname)->next->string,tmpstr)==0){
    tn=(*tmpname)->next->next;
    (*tmpname)->next->next=0;
    destroy_node((*tmpname)->next);
    (*tmpname)->next=tn;
    return 1;
  }
  while ((tn->next)&&(tn->next->string)){
    if(strcmp(tn->next->string,tmpstr)==0){
      tn1=tn->next->next;
      tn->next->next=0;
      destroy_node(tn->next);
      tn->next=tn1;
      return 1;
    } 
    tn=tn->next;
  }
  return 0;
}
int inif (struct ListNode *tmpname, char tmpstr[]){
  struct ListNode *tn=tmpname;
  if(!tmpname)return 0;
  if(!tmpname->string)return 0;
  if(strcmp(tmpname->string,tmpstr)==0)return 1;
  if(!tmpname->next)return 0;
  if(!tmpname->next->string)return 0;
  if(strcmp(tmpname->next->string,tmpstr)==0)return 1;
  while ((tn->next->next)&&(tn->next->next->string)){
    if(strcmp(tn->next->next->string,tmpstr)==0)return 1;
    tn=tn->next;
  }
  return 0;
}

void pushbigif(struct ListNode **dest, struct ListNode *source){
  struct ListNode *ptr, *tmp;
  while(source){
    if(!inif(*dest,source->string)){
      ptr=(struct ListNode *)malloc(sizeof (struct ListNode));
      if(ptr){
        ptr->string=source->string;
        source->string=0;
      }
      tmp=*dest;
      *dest=ptr;
      (*dest)->next=tmp;
    }
    source=source->next;
  }
  destroy_node(source);
}

void sort(struct ListNode **head, int size){
	struct ListNode *tmp=create_node(""),*tmp2, *tmp0, *tmp00;
	int x=1,y=1,len=0;
	if (size<2)return;
	if ((*head==0)||((*head)->next)==0)return;
	tmp->next=*head;
	tmp2=tmp;
  while (tmp2->next){
		tmp2=tmp2->next;
		len++;
	}
  if (size<len)len=size;
    for (y=1;y<=len-1;y++){
		tmp2=tmp;
		for (x=1;x<=len-y;x++){
			if(strcmp(tmp2->next->string,tmp2->next->next->string)==1){
				tmp0=tmp2->next;
				tmp2->next=tmp2->next->next;
				tmp00=tmp2->next->next;
				tmp2->next->next=tmp0;
				tmp2->next->next->next=tmp00;
			}
			tmp2=tmp2->next;
		}
	}
	*head=tmp->next;
	tmp->next=0;
	destroy_node(tmp);
}
